* new function to extend basic, for matching strings containing wild
* characters represented by '?' in a string, any number of '?'s
*
* V1.00 (actually worked first time!) written by Dilwyn Jones 23/8/94
* public domain piece of machine code
* originally intended for use with the Solvit-Plus program by 
* Geoff Wicks, if the speedup proves worthwhile, no doubt this first
* attempt can be improved upon further with a little effort!
*
* result% = MATCH%('wild_string','string2')
*
* string 1 is the one allowed to contain '?' characters as wildcard
* result% = 0 means not matched, or different lengths
* result% = 1 means matched and same length
* e.g. '??pp?' matches with 'happy'
*
* case independent searches (lower == upper case)

        lea     procdef,a1      ;definition block
        move.w  $110,a2         ;bp.init
        jsr     (a2)            ;extend basic
        rts                     ;return to basic

procdef dc.w    0               ;approximately 0 procedures
        dc.w    0               ;end of procedures
        dc.w    1,match-*       ;1 function at match-*
        dc.b    6,'MATCH%',0    ;name+align
        dc.w    0               ;end of functions

match   move.w  $116,a2         ;ca.gtstr
        jsr     (a2)            ;fetch all string parameters
        beq.s   ok1             ;no error
err_bp  moveq   #-15,d0         ;bad parameter error report
        rts                     ;back to basic
ok1     cmpi.w  #2,d3           ;2 parameters?
        bne.s   err_bp          ;oops

* we now have both string parameters on the stack ready to
* match, so first of all check that the length of both is
* the same, to do that we need to find the length words
        move.w  0(a6,a1.l),d0   ;length of string 1
        move.w  d0,d3           ;copy of actual length to be rounded
        move.l  a1,a2           ;copy of stack pointer
        addq.l  #3,d3           ;2 bytes for length word + 1 to round
        bclr    #0,d3           ;ensure even value
        add.l   d3,a2           ;offset to length word of string 2
        move.w  0(a6,a2.l),d1   ;length word
        move.w  d0,d4           ;copy of length
        cmp.w   d0,d1           ;both lengths the same?
        bne.s   unmatch         ;no, return a 0 for unmatched strings

* having validated that both strings are the same length we can now
* check the individual bytes of the string one by one, allowing ? to
* match with anything, beware that odd length strings can leave one
* extra unused pad byte on the stack to word align the strings
* lower case == upper case, i.e. ASCII 65 to 90 == 97 to 122

* check for special case of two null strings
        tst.w   d0              ;null?
        beq     matched         ;yes, return 1

* prepare running pointers to both

        move.l  a1,$58(a6)      ;store RI stack pointer to bv.rip
        addq.l  #2,a1           ;first character of string 1
        addq.l  #2,a2           ;first character of string 2
        move.w  d0,d2           ;length counter to use as loop index
        subq.w  #1,d2           ;prepare for dbf

loop    move.b  0(a6,a1.l),d5   ;character from string 1
        cmpi.b  #'?',d5         ;wildcard?
        beq.s   matched         ;yes, no need to test it further


* remove this bit if case independence not required
        cmpi.b  #'@',d5         ;less than A?
        bls.s   ok2             ;yes
        cmpi.b  #'Z',d5         ;higher than Z?
        bhi.s   ok2             ;yes
        addi.b  #32,d5          ;convert to lower case
ok2     move.b  0(a6,a2.l),d6   ;character from string 2
        cmpi.b  #'@',d6         ;less than A?
        bls.s   ok3             ;yes, no need to change case
        cmpi.b  #'Z',d6         ;higher than Z?
        bhi.s   ok3             ;yes
        addi.b  #32,d6          ;convert to lower case
* end of 'case independence' code, resume here


ok3     cmp.b   d5,d6           ;are they the same?
        bne.s   unmatch         ;no, bale out to return 0
        addq.l  #1,a1           ;next character in string 1
        addq.l  #1,a2           ;next character in string 2
        dbf     d2,loop         ;next character, if any

* if it got to here, the strings matched, so return a 1
matched moveq   #1,d7           ;yes, return 1 for matched
        bra.s   ret_res         ;success, return result
unmatch clr.l   d7              ;no match, return 0
ret_res move.l  $58(a6),a1      ;recover RI stack pointer
        ext.l   d3              ;prepare to adjust RI stack pointer
        add.l   d3,a1           ;point to second string
        subq.l  #2,d3           ;allow room for word length return
        add.l   d3,a1           ;word goes here
        move.l  a1,$58(a6)      ;store RI stack pointer
        move.w  d7,0(a6,a1.l)   ;stack the result
        moveq   #3,d4           ;return a 16 bit integer result
        moveq   #0,d0           ;no error return to basic
        rts                     ;and go back to basic
