* Tiny Toolkit

* QDOS constants

ERR.NO   equ -6
ERR.BP   equ -15
ERR.OV   equ -18

MT.INF   equ 0
MT.SUSJB equ 8
MT.DMODE equ $10
MT.ALCHP equ $18
MT.RECHP equ $19
MT.LPOLL equ $1C

SV_PLIST equ $3C

IO.OPEN  equ 1
IO.CLOSE equ 2
IO.DELET equ 4

SD.EXTOP equ 9

SD_XINC  equ $26

BP.INIT  equ $110
CA.GTINT equ $112
CA.GTFP  equ $114
CA.GTSTR equ $116
CA.GTLIN equ $118
BV.CHRIX equ $11A
BP.LET   equ $120

BV_CHBAS equ $30
BV_CHP   equ $34
BV_RIP   equ $58
CH.LENCH equ $28

T.STR    equ 1
T.FP     equ 2
T.INT    equ 3

        section QVTK
        data    0
        lea     tab,a1
        move.w  BP.INIT,a2
        jmp     (a2)

np setnum 0
cp setnum 0
nf setnum 0
cf setnum 0

b macro w,t
n[w] setnum [n[w]]+1
c[w] setnum [c[w]]+[.len(t)]+1
t[w][n[w]] setstr [t]
b[w][n[w]] ds.w 0
 endm

g macro w
n setnum ([c[w]]+7)/8
 ifnum [n] > [n[w]] goto p
n setnum [n[w]]
p maclab
[.lab] dc.w [n]
 ifnum [n] = 0 goto q
i setnum 0
l maclab
i setnum [i]+1
 dc.w b[w][i]-*
 dc.b [.len(t[w][i])],'[t[w][i]]'
 ifnum [i] < [n[w]] goto l
q maclab
 dc.w 0
 endm

tkv5 dc.b 'QVTK1.3'
tkve equ *
 ds.w 0

* N.B. d0 is kept zero as much possible, to enable efficient code.

* $00 longword tick count (TTV-64)
* $04 addq.l #1,(a3):rts
* $08 linkage into poll list
* $0C poll routine address = *-8
* $10 11 spare longs (TTV-48 .. TTV-5)
* $3C dc.w 2,'QV' identifier
* $40..$EF 176 bytes of workspace (TTV .. TTV+175)
* $F0 end of area

vloop
        move.l  d2,a0
        cmp.l   $3C-$08(a0),d5
        beq.s   vfound
vfent
        move.l  (a0),d2
        bne.s   vloop (owner job 0 if dropping out here)
        moveq   #$F0>>1,d1
        add.b   d1,d1
        moveq   #MT.ALCHP,d0
        trap    #1
        tst.l   d0
        bne.s   rts0
        move.l  d5,$3C(a0)
        addq.l  #$04,a0
        move.l  a0,$0C-$04(a0)
        dc.w    $20FC move.l #<following longword>,(a0)+
        addq.l  #1,(a3)
rts0
        rts
        moveq   #MT.LPOLL,d0
        trap    #1
vfound
        add.l   a0,d7
        bra.l   retlin

 b f TTV ;{(offset{,off}...)}: work area + offsets.

        moveq   #MT.INF,d0
        trap    #1
        move.l  #2<<16!'QV',d5
        add.w   #SV_PLIST,a0
        moveq   #$40-$08,d7
vnlp
        cmp.l   a3,a5
        beq.s   vfent
        bsr.s   gtlin1
        add.l   d3,d7
        bra.s   vnlp

 b f TTEFP ;(var,value): Assign value to FP variable. Return error code.

        moveq   #15,d7
        and.b   1(a6,a3.l),d7
        add.w   #2*8,a3
        subq.b  #T.FP,d7
        bne.s   bprts1
        cmp.l   a5,a3
        bne.s   bprts1
        subq.l  #8,a3
        move.w  CA.GTFP,a2
        jsr     (a2)
        bne.s   reterr1
        subq.l  #8,a3
        move.w  BP.LET,a2
        jsr     (a2)
        bra.s   reterr1

notime
        move.l  d3,a4           a4=start d1=timeout
        move.l  d1,d3
        move.l  d2,d0
        movem.l (a4),d1-d2/a1-a2
        trap    #3
        movem.l d1-d2/a1,(a4)
reterr1
        bra.s   reterr

 b f TTET3 ;({#chan;}{timeout,}op,start): Call system trap #3 and return info.
* d1, d2, a1 and a2 are fetched from a 16 byte area at start for a trap #3.
* d1 and a1 are put back there. No checks are made.

        bsr.l   chan
        moveq   #-1,d3
        bsr.s   gtlin1
        bsr.s   gtlin1
        beq.s   notime
        bsr.s   gtlin1
        beq.s   notime

bprts1
        moveq   #ERR.BP,d0
rts1
        rts

ischan
        cmp.l   a5,a3
        bpl.s   rts1
        tst.b   1(a6,a3.l)
        rts

gtchan
        mulu    #CH.LENCH,d3
        add.l   BV_CHBAS(a6),d3
        bcs.s   bprts1
        cmp.l   BV_CHP(a6),d3
        bcc.s   rts1
        move.l  d3,a4
        move.l  0(a6,a4.l),a0
        rts

gtlin1
        bra.l   gtlin

 b f TTEDELETE ;(name): Delete a file returning any error code.

        bsr.l   gtstr
        bne.s   bprts1
        moveq   #IO.DELET,d0
trap2
        moveq   #-1,d1
        move.l  d3,d4
        move.l  d2,d3
        lea     -2(a1),a0
        trap    #4
        trap    #2
        moveq   #1,d1
        and.l   d4,d1
        add.l   d4,d1
        add.l   d1,BV_RIP(a6)
reterr
        move.l  d0,d7
retlin1
        bra.l   retlin

 b f TTEOPEN ;(#chan;{type,}name): Open file, def type 0, return error code.

        bsr.s   ischan
        bpl.s   bprts1
        bsr.s   gtlin1
        bsr.s   gtchan
        bcc.s   bprts1
        move.l  a0,d3
        bmi.s   noclose
        moveq   #IO.CLOSE,d0
        trap    #2
        st      0(a6,a4.l)
noclose
        moveq   #0,d3
        bsr.s   qleft
        subq.l  #8,d0
        beq.s   notype
        bsr.s   gtlin1
notype
        bsr.l   gtstr
bpne1
        bne.s   bprts1
        moveq   #IO.OPEN,d0
        bsr.s   trap2
        tst.l   d7
        bne.s   rts1
        move.l  a0,0(a6,a4.l)
        rts

 b p TTINC ;{#chan;}x,y: Set cursor x/y increments in chan.

        bsr.s   chan
        bsr.s   gtint
        bsr.s   gtint
        bne.s   bpne1
        move.w  d3,a1
        lea     extop,a2
        moveq   #SD.EXTOP,d0
        moveq   #-1,d3
* trap #4 ... no calls require this (yet?)
        trap    #3
trapx
        move.l  d0,d7
        rts

chri4
        moveq   #4,d1
        bra.s   chriy

bppop
        moveq   #ERR.BP,d0
chpop
        addq.l  #4,sp
        rts

chan
        moveq   #1,d3           default to channel #1
        bsr.l   ischan
        bpl.s   chok
        bsr.s   gtint
chok
        bsr.l   gtchan
        bcc.s   bppop
        moveq   #ERR.NO,d0
        move.l  a0,d3
        bmi.s   chpop
qleft
        move.l  a5,d0
        sub.l   a3,d0
        rts

gtint
        moveq   #CA.GTINT-CA.GTLIN,d0
        bra.s   gtany1

*-------------------------- rts1 / rts5

 b p TTSUS ;ticks: Suspend job for a given time.

        bsr.s   gtint
        bne.s   bprts5
        tst.w   d3
        bmi.s   bprts5
        sub.l   a1,a1
        moveq   #MT.SUSJB,d0
trap1a
        moveq   #-1,d1
trap1
        trap    #1
        bra.s   trapx

 b f TTMODE% ;: return the current display mode setting. 0/8=4/8 colour.

        cmp.l   a3,a5
        bne.s   bprts5
        moveq   #-1,d2
        moveq   #MT.DMODE,d0
        bsr.s   trap1a
        ext.w   d1

retd1w
        move.w  d1,d7
        ext.l   d7
retlin
        moveq   #T.INT,d4
        move.w  d7,d3
        ext.l   d3
        cmp.l   d3,d7
        beq.s   rnow
        move.w  #$81f,d3
        bsr.s   chri4
rnorm
        move.l  d7,0(a6,a1.l)
        add.l   d7,d7
        dbvs    d3,rnorm
        moveq   #T.FP,d4
rnow
        moveq   #2,d1
chriy
        bra.s   chrix

 b p TTREL ;address: Release common heap at address.

        bsr.s   gtlin
        bne.s   bprts5
        move.l  d3,a0
        moveq   #MT.RECHP,d0
        bra.s   trap1

 b f TTME% ;: returns own job number.

        cmp.l   a3,a5
        bne.s   bprts5
        moveq   #MT.INF,d0
        trap    #1
        bra.s   retd1w

 b f TTALL ;({job,}size): Allocate from common heap to self or job.

        moveq   #-1,d3
        bsr.s   gtlin
        beq.s   nojob
        bsr.s   gtlin
        bne.s   bprts5
nojob
        move.l  d3,d1
        moveq   #MT.ALCHP,d0
        bsr.s   trap1
        beq.s   reta0
        sub.l   a0,a0
reta0
        move.l  a0,d7
        bra.s   retlin

gtlin
        moveq   #CA.GTLIN-CA.GTLIN,d0
gtany1
        bra.s   gtany

bprts5
        moveq   #ERR.BP,d0
        rts

chrix
        movem.l d1-d3,-(sp)
        move.w  BV.CHRIX,a2
        jsr     (a2)
        move.l  BV_RIP(a6),a1
        movem.l (sp)+,d1-d3
        sub.l   d1,a1
        bsr.s   putrip
        move.w  d3,0(a6,a1.l)
        moveq   #0,d0
        rts

 b f TTFINDM ;(start,size,string): Find string wholely in specified area.

        bsr.s   gtlin
        bsr.s   gtlin
        bsr.s   gtstr           d1=start d2=size d3=len
        bne.s   bprts5
        move.l  d1,a0
        add.l   d1,d2
        sub.l   d3,d2
        move.b  0(a6,a1.l),d7   first byte
        move.l  a1,d5
        add.w   d3,a1
        ror.w   #1,d3
        smi     d3
        bne.s   f5enter
        move.b  (a0),d7         fiddle to make '' match at 1

f5outer
        cmp.b   (a0)+,d7
        bne.s   f5enter
        move.l  a0,a4
        move.l  d5,a2
f5inner
        addq.l  #1,a2
        cmp.l   a1,a2
        bcc.s   f5found
        move.b  (a4)+,d6
        cmp.b   0(a6,a2.l),d6
        beq.s   f5inner
f5enter
        cmp.l   a0,d2
        bcc.s   f5outer
        move.l  d1,a0

f5found
        ext.w   d3
        sub.w   d3,a1
        bsr.s   putrip
        sub.l   d1,a0
        bra.s   reta0

gtstr
        moveq   #CA.GTSTR-CA.GTLIN,d0
gtany
        movem.l d0/d2-d3/a0/a5,-(sp)
        cmp.l   a5,a3
        bcc.s   gtebp
        lea     8(a3),a5
        move.w  d0,a0
        move.w  CA.GTLIN(a0),a0
        jsr     (a0)
        bne.s   gtbad
        move.l  a5,a3
        move.l  0(a6,a1.l),d3
        addq.l  #4,a1
        tst.l   (sp)+
        beq.s   waslin
        subq.l  #2,a1
        swap    d3
        ext.l   d3
waslin
        movem.l (sp)+,d1-d2/a0/a5
putrip
        move.l  a1,BV_RIP(a6)
        bra.l   qleft

gtebp
        moveq   #ERR.BP,d0
gtbad
        add.w   #6*4,sp         discard stack and return address
        rts

*-------------------------- rts5 / rts8

 b f TTPEEK$ ;(start,size): Return area as a string.

        bsr.s   gtlin2
        move.l  d3,a4
        bsr.l   gtint
        bra.s   peeks

gtlin2
        moveq   #CA.GTLIN-CA.GTLIN,d0
        bra.s   gtany

 b f TT$ ;: Return version string.

        moveq   #tkve-tkv5,d3
        lea     tkv5,a4

peeks
        cmp.l   a3,a5
        bne.s   bprts8
        moveq   #ERR.OV,d0
        move.l  d3,d6
        bmi.s   rts8
        moveq   #T.STR,d4
        and.w   d4,d6
        add.l   d3,d6
        move.l  d6,d1
        addq.l  #2,d1
        bsr.l   chrix
        move.l  a1,a0
        asr.l   #1,d6
        bra.s   p5ent

 b p TTPOKE$ ;to,string: Poke string into memory.

        bsr.s   gtlin2
        move.l  d3,a4
        bsr.s   gtstr           a4=to d3=length
        beq.s   pent

bprts8
        moveq   #ERR.BP,d0
rts8
        rts

p5lp
        move.b  (a4)+,d3
        lsl.w   #8,d3
        move.b  (a4)+,d3
        addq.l  #2,a0
        move.w  d3,0(a6,a0.l)
p5ent
        dbra    d6,p5lp
        rts

ploop
        move.b  0(a6,a1.l),(a4)+
        addq.l  #1,a1
pent
        dbra    d3,ploop
        rts

 b p TTPOKEM ;to,start,size: approx. to TTPOKE$ to,TTPEEK$(start,size).
* This will repeat overlaps only if the first delimiter is '!' (or 'TO').

        move.w  0(a6,a3.l),d7
        bsr.s   gtlin2
        bsr.s   gtlin2
        bsr.s   gtlin2          d1=to d2=start d3=size
        bne.s   bprts8
        sub.l   d1,d2
        beq.s   rts9
        move.l  d2,a1
        bpl.s   ohigh
        neg.l   d2
        not.b   d7
ohigh
        add.b   d7,d7           (! or TO set sign bit)
        bpl.s   up
        add.l   d3,d1
up
        move.l  d1,a0
        add.l   d1,a1
        asr.w   #1,d1
        bcc.s   outeven
        subq.w  #1,d3
        bcs.s   rts9
        tst.b   d7
        bmi.s   downodd
        move.b  (a1)+,(a0)+
        bra.s   outeven

ucswp
        swap    d3
uchar
        move.b  (a1)+,(a0)+
ucent
        dbra    d3,uchar
        swap    d3
        dbra    d3,ucswp
okret
        moveq   #0,d0
rts9
        rts

dcswp
        swap    d3
dchar
        move.b  -(a1),-(a0)
dcent
        dbra    d3,dchar
        swap    d3
        dbra    d3,dcswp
        bra.s   okret

downodd
        move.b  -(a1),-(a0)
outeven
lump reg d0-d2/d5-d7/a2-a5
        moveq   #4*10,d4        size of lump
        cmp.l   d4,d2
        bcs.s   slow
        asr.w   #1,d2
        bcs.s   slow
        tst.b   d7
        bmi.s   dfent
        bra.s   ufent

slow
        tst.b   d7
        bmi.s   dcent
        bra.s   ucent

ufast
        movem.l (a1)+,lump
        movem.l lump,(a0)
        add.l   d4,a0
ufent
        sub.l   d4,d3
        bge.s   ufast
        add.l   d4,d3
        bra.s   ucent

dfast
        sub.l   d4,a1
        movem.l (a1),lump
        movem.l lump,-(a0)
dfent
        sub.l   d4,d3
        bge.s   dfast
        add.l   d4,d3
        bra.s   dcent

extop
        movem.w d2/a1,SD_XINC(a0) & SD_YINC
        bra.s   okret

tab
 g p
 g f

        end
